---
layout: page
title: Restomax API Metadata
permalink: /restomax-metadata/
date: 2021-12-10 10:15
---

# Install
Width Dart:
```
dart pub add resto5_models
```
With Flutter:
```
flutter pub add resto5_models
```

# restomax-rpcalls
Restomax auto generated help by PublishMetadata Script (text/markdown formatted)  
Version: RestoCmd.exe. 5.21.12.10 Dte: 10.12.21 10:00 LastW: 10.12.21 05:00. DB: FB2-RESTO5.83
- Warning: Please be advised that the information and data contained below is meant for reference purposes only and is subject to change without warning.
- Copyright and other Intellectual: Property Rights.The whole content of this api is subject to Restomax copyrights and remain the property of Restomax.  
  Any reproduction, transfer, alteration or utilization of the website and of the logo of Restomax for a public and/or commercial purpose without prior written consent of Restomax is prohibited.
- Install a [Markdown Viewer](https://github.com/simov/markdown-viewer)
- Install a [Typescript Viewer](https://chrome.google.com/webstore/detail/pretty-beautiful-javascri/piekbefgpgdecckjcpffhnacjflfoddg)


# restomax api access routes (EndPoints)
- Restomax Internal Websocket WAMPv1 RPC (original route)
- Restomax Internal WebServer   
  access/security managed by LAN Admim
- Restomax Jabber VPN EntryPoint  
  test using rpnInst.exe rpn:aJabberLogin action params  
  test using curl <http://fire.restomax.com:8080/action?IID=demo-123456&staff=123456&action=Help>  
  test using postman :)
- APIs can be consumed in any language but Restomax advice TypeScript (using npm).  
  Most RPC expect json body but some also accept http query params.  
  If you provide both, query params are **merged** into json body.


# restomax api CRUD ops (Create/Read/Update/Delete)
- restomax api ignore Http method (Get/Set/...) may change in future
- restomax api is mapping Websocket RPC to URL GetXXXs,GetXXX,SetXXX,DelXXX  
  example to handle Articles(PLU)    
  Resto:GetArticles : Search/Read all Articles    
  Resto:GetArticle : Read ONE Article    
  Resto:SetArticle : Update ONE Article  
  Resto:DelArticle : Delete ONE Article
- restomax api GetXXX operation can be normal or simplified  
  by adding to the Body Args Object, the property __simplified__ true|false.  
  in simplified mode, all properties will be returned (coalescing to default value).
- restomax api SetXXX operation can be partial or full    
  by adding to the Body Args Object, the property __SetMode__ set to __OnlyModif | Full__    
  OnlyModif : will update only properties received  
  Full : will update all properties. (setting missing props to default).
- restomax api legacy  
  still implement special Del as Set with Object Property __SetMode__ set to __Delete__


# restomax api Select ops
- all select ops can be filtered using simple {SearchKey:yyy,SearchVal:xxx|regex:xxx} criteria    
  where yyy is a fieldname and xxx wanted value
- example to select some Articles(PLU)    
  Resto:GetArticles&{SearchVal:11,SearchKey:Categorie} : Search/Read all Articles in Categorie=11  
  Resto:GetArticles : Search/Read all Articles

# RPCs List
* [Ping](#ping)
* [Help](#help)
* [Resto:GetMetaData](#restogetmetadata)
* [Resto:GetRestoDBObjs](#restogetrestodbobjs)
* [Resto:GetRestoDBObj](#restogetrestodbobj)
* [Resto:GetRptCodes](#restogetrptcodes)
* [Resto:GetRptList](#restogetrptlist)
* [Resto:GetRptInfo](#restogetrptinfo)
* [Resto:GetData](#restogetdata)
* [Resto:SetData](#restosetdata)
* [Resto:GetEtab](#restogetetab)
* [Resto:ClotureSvc](#restocloturesvc)
* [Resto:OpenSvc](#restoopensvc)
* [Resto:ClotureStaff](#restocloturestaff)
* [Resto:OpenStaff](#restoopenstaff)
* [Resto:ClockOutStaff](#restoclockoutstaff)
* [Resto:ClockInStaff](#restoclockinstaff)
* [Resto:GetEtabParam](#restogetetabparam)
* [Resto:SetEtabParam](#restosetetabparam)
* [Resto:GetImages](#restogetimages)
* [Resto:GetImage](#restogetimage)
* [Resto:SetImage](#restosetimage)
* [Resto:DelImage](#restodelimage)
* [Resto:GetStations](#restogetstations)
* [Resto:GetStation](#restogetstation)
* [Resto:SetStation](#restosetstation)
* [Resto:DelStation](#restodelstation)
* [Resto:GetDivisions](#restogetdivisions)
* [Resto:GetDivision](#restogetdivision)
* [Resto:SetDivision](#restosetdivision)
* [Resto:DelDivision](#restodeldivision)
* [Resto:GetAccueil](#restogetaccueil)
* [Resto:GetStaffs](#restogetstaffs)
* [Resto:GetStaff](#restogetstaff)
* [Resto:SetStaff](#restosetstaff)
* [Resto:DelStaff](#restodelstaff)
* [Resto:GetSalles](#restogetsalles)
* [Resto:GetTblBtns](#restogettblbtns)
* [Resto:GetTblBtn](#restogettblbtn)
* [Resto:SetTblBtn](#restosettblbtn)
* [Resto:DelTblBtn](#restodeltblbtn)
* [Resto:GetTables](#restogettables)
* [Resto:GetTable](#restogettable)
* [Resto:SetTable](#restosettable)
* [Resto:DelTable](#restodeltable)
* [Resto:GetMvtTbls](#restogetmvttbls)
* [Resto:GetCarte](#restogetcarte)
* [Resto:GetCategs](#restogetcategs)
* [Resto:GetCateg](#restogetcateg)
* [Resto:SetCateg](#restosetcateg)
* [Resto:DelCateg](#restodelcateg)
* [Resto:GetGroups](#restogetgroups)
* [Resto:GetGroup](#restogetgroup)
* [Resto:SetGroup](#restosetgroup)
* [Resto:DelGroup](#restodelgroup)
* [Resto:GetTariffColors](#restogettariffcolors)
* [Resto:GetTariffColor](#restogettariffcolor)
* [Resto:SetTariffColor](#restosettariffcolor)
* [Resto:DelTariffColor](#restodeltariffcolor)
* [Resto:GetSimplifiedArticles](#restogetsimplifiedarticles)
* [Resto:GetArticles](#restogetarticles)
* [Resto:GetArticle](#restogetarticle)
* [Resto:SetArticle](#restosetarticle)
* [Resto:DelArticle](#restodelarticle)
* [Resto:GetArticlesStocks](#restogetarticlesstocks)
* [Resto:GetArticleStock](#restogetarticlestock)
* [Resto:GetSuppliers](#restogetsuppliers)
* [Resto:GetStockDocs](#restogetstockdocs)
* [Resto:GetStockDoc](#restogetstockdoc)
* [Resto:SetStockDoc](#restosetstockdoc)
* [Resto:DelStockDoc](#restodelstockdoc)
* [Resto:GetEncaisse](#restogetencaisse)
* [Resto:GetModePays](#restogetmodepays)
* [Resto:GetModePay](#restogetmodepay)
* [Resto:SetModePay](#restosetmodepay)
* [Resto:DelModePay](#restodelmodepay)
* [Resto:GetRoutes](#restogetroutes)
* [Resto:GetPtrs](#restogetptrs)
* [Resto:GetPtrLnks](#restogetptrlnks)
* [Resto:TicketStatus](#restoticketstatus)
* [Resto:GetMember](#restogetmember)
* [Resto:SetMember](#restosetmember)
* [Resto:GetMembers](#restogetmembers)
* [Resto:GetMemberPhoto](#restogetmemberphoto)
* [Resto:SetMemberPhoto](#restosetmemberphoto)
* [Resto:GetMemberPoints](#restogetmemberpoints)
* [Resto:SetMemberPoints](#restosetmemberpoints)
* [Resto:GetResource](#restogetresource)
* [Resto:GetUrl](#restogeturl)
* [Resto:GetUri](#restogeturi)
* [Resto:GetHisto](#restogethisto)
* [Resto:GetArchive](#restogetarchive)
* [Resto:GetView](#restogetview)
* [Resto:GetRpt](#restogetrpt)
* [Resto:GetLedger](#restogetledger)
* [Resto:GetDashBoard](#restogetdashboard)
* [Resto:GetSvcDashBoard](#restogetsvcdashboard)
* [Resto:GetPointage](#restogetpointage)
* [Resto:SetPointage](#restosetpointage)
* [Resto:Action](#restoaction)

---
## Ping
* **Descr**: Should just anwer {Pong:DateTime}
* **Response content-type**: text/json

* **Demo Urls**
> [Ping](http://demo.restomax.com:1307/action?action=Ping)

---
## Help
* **Descr**: Describe Restomax RPC(s)
* **Request**: None or WantedAction or [Action,...]
* **Response**: Describe Restomax RPC(s)
* **Response content-type**: text/markdown

* **Demo Urls**
> [Help&Help=Ping](http://demo.restomax.com:1307/action?action=Help&Help=Ping)  
> [Help&Help=GetEtab](http://demo.restomax.com:1307/action?action=Help&Help=GetEtab)

---
## Resto:GetMetaData
* **Descr**: Describe Restomax API Intf/Obj
* **ObjectName**: Etab,Station,Service,Division,...
* **Request**: None or ObjectName or [ObjectNames]
* **Response content-type**: text/typescript

* **Demo Urls**
> [Resto:GetMetaData&GetMetaData=Etab](http://demo.restomax.com:1307/action?action=Resto:GetMetaData&GetMetaData=Etab)  
> [Resto:GetMetaData&GetMetaData=Etab&GetMetaData=Station](http://demo.restomax.com:1307/action?action=Resto:GetMetaData&GetMetaData=Etab&GetMetaData=Station)  
> [Resto:GetMetaData&GetMetaData=[Etab,Station]](http://demo.restomax.com:1307/action?action=Resto:GetMetaData&GetMetaData=[Etab,Station])

---
## Resto:GetRestoDBObjs
* **Descr**: Return DBObj List
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetRestoDBObjs](http://demo.restomax.com:1307/action?action=Resto:GetRestoDBObjs)

---
## Resto:GetRestoDBObj
* **Descr**: Return DBObj
* **Request**: Wanted DBObj Name
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetRestoDBObj&Obj=Article](http://demo.restomax.com:1307/action?action=Resto:GetRestoDBObj&Obj=Article)

---
## Resto:GetRptCodes
* **Descr**: Return Rpts List
* **Response**: All Rpts Codes List. Array of [IR5RptCode](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5RptCode.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetRptCodes](http://demo.restomax.com:1307/action?action=Resto:GetRptCodes)

---
## Resto:GetRptList
* **Descr**: Return Rpts List
* **Response**: All Rpts Codes List. [IR5RptInfo](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5RptInfo.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetRptList](http://demo.restomax.com:1307/action?action=Resto:GetRptList)

---
## Resto:GetRptInfo
* **Descr**: Return Rpt Info
* **Request**: Wanted Rpt=xxx
* **Response**: Rpt Info. [IR5RptInfo](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5RptInfo.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetRptInfo&Rpt='010'](http://demo.restomax.com:1307/action?action=Resto:GetRptInfo&Rpt='010')  
> [Resto:GetRptInfo&Rpt='011'](http://demo.restomax.com:1307/action?action=Resto:GetRptInfo&Rpt='011')

---
## Resto:GetData
* **Descr**: Return all objects data
* **Response**: [IR5GetDataIntf](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5GetDataIntf.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetData](http://demo.restomax.com:1307/action?action=Resto:GetData)

---
## Resto:SetData
* **Descr**: Update/Insert/Delete passed object(s)
* **Request**: {Staff:Login,Data:IData | SingleObj,SetMode:OnlyModif} [IR5GetDataIntf](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5GetDataIntf.ts)  
  Use : SetMode:[OnlyModif,Full,Delete] (default OnlyModif)  
  For Objs Array, Obj not present are deleted iff SetMode ...
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetData&{"Data":{"Article":{"Nom":"Test","No":"TEST"}},"Staff":123456}](http://demo.restomax.com:1307/action?action=Resto:SetData&{"Data":{"Article":{"Nom":"Test","No":"TEST"}},"Staff":123456})

---
## Resto:GetEtab
* **Descr**: Return Etab
* **Response**: [IR5Etab](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Etab.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetEtab](http://demo.restomax.com:1307/action?action=Resto:GetEtab)

---
## Resto:ClotureSvc
* **Descr**: Cloture Service
* **Request**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:ClotureSvc&Staff=123456&Station=1](http://demo.restomax.com:1307/action?action=Resto:ClotureSvc&Staff=123456&Station=1)

---
## Resto:OpenSvc
* **Descr**: Open Service
* **Request**: Require Staff,Station,Svc   
  Svc : { Dte:yyymmdd, No?:xxx}
* **Response**: [IR5Etab](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Etab.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:OpenSvc&Staff=123456&Station=123456](http://demo.restomax.com:1307/action?action=Resto:OpenSvc&Staff=123456&Station=123456)  
> [Resto:OpenSvc&Staff=123456&Station=123456&Svc={Dte:20191016,No:1}](http://demo.restomax.com:1307/action?action=Resto:OpenSvc&Staff=123456&Station=123456&Svc={Dte:20191016,No:1})

---
## Resto:ClotureStaff
* **Descr**: Cloture Staff
* **Request**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:ClotureStaff](http://demo.restomax.com:1307/action?action=Resto:ClotureStaff)

---
## Resto:OpenStaff
* **Descr**: Open Staff
* **Request**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:OpenStaff](http://demo.restomax.com:1307/action?action=Resto:OpenStaff)

---
## Resto:ClockOutStaff
* **Descr**: ClockOut Staff
* **Request**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:ClockOutStaff](http://demo.restomax.com:1307/action?action=Resto:ClockOutStaff)

---
## Resto:ClockInStaff
* **Descr**: ClockIn Staff
* **Request**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:ClockInStaff](http://demo.restomax.com:1307/action?action=Resto:ClockInStaff)

---
## Resto:GetEtabParam
* **Descr**: Return EtabExtParam
* **Request**: {Key:xx}
* **Response**: {Key:xx,Value=yyy,Bin=zzz}
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetEtabParam&{Key:Test}](http://demo.restomax.com:1307/action?action=Resto:GetEtabParam&{Key:Test})

---
## Resto:SetEtabParam
* **Descr**: Update/Insert/Delete EtabExtParam
* **Request**: {Key:xx,Value=yyy,Bin=zzz}
* **Response**: {Key:xx,Value=yyy,Bin=zzz}
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetEtabParam&{Key:Test,Value:Test}](http://demo.restomax.com:1307/action?action=Resto:SetEtabParam&{Key:Test,Value:Test})

---
## Resto:GetImages
* **Descr**: Return Images
* **Response**: Array of [IR5Image](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Image.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetImages](http://demo.restomax.com:1307/action?action=Resto:GetImages)

---
## Resto:GetImage
* **Descr**: Return Image
* **Request**: [IR5Image](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Image.ts)
* **Response**: [IR5Image](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Image.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetImage&Image=200](http://demo.restomax.com:1307/action?action=Resto:GetImage&Image=200)

---
## Resto:SetImage
* **Descr**: Update/Insert Selected Image
* **Request**: [IR5Image](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Image.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetImage&Image=300&Description=Test](http://demo.restomax.com:1307/action?action=Resto:SetImage&Image=300&Description=Test)

---
## Resto:DelImage
* **Descr**: Delete Selected Image
* **Request**: [IR5Image](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Image.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:DelImage&Image=999](http://demo.restomax.com:1307/action?action=Resto:DelImage&Image=999)

---
## Resto:GetStations
* **Descr**: Return Stations
* **Response**: Array of [IR5Station](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Station.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetStations](http://demo.restomax.com:1307/action?action=Resto:GetStations)

---
## Resto:GetStation
* **Descr**: Return Station
* **Request**: 123 | {Station:xxx} | {No:123 | FiscalId:456 | MacAddress:xxx} [IR5Station](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Station.ts) or  NumStation
* **Response**: [IR5Station](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Station.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetStation&Station=1](http://demo.restomax.com:1307/action?action=Resto:GetStation&Station=1)

---
## Resto:SetStation
* **Descr**: Update/Insert Selected Station
* **Request**: 123 | {Station:xxx} | {No:123 | FiscalId:456 | MacAddress:xxx} [IR5Station](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Station.ts) or  NumStation
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetStation&Station=1&Description=Test](http://demo.restomax.com:1307/action?action=Resto:SetStation&Station=1&Description=Test)

---
## Resto:DelStation
* **Descr**: Delete Selected Station
* **Request**: 123 | {Station:xxx} | {No:123 | FiscalId:456 | MacAddress:xxx} [IR5Station](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Station.ts) or  NumStation
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:DelStation&Station=999](http://demo.restomax.com:1307/action?action=Resto:DelStation&Station=999)

---
## Resto:GetDivisions
* **Descr**: Return Divisions
* **Response**: IR5Divisions
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetDivisions](http://demo.restomax.com:1307/action?action=Resto:GetDivisions)

---
## Resto:GetDivision
* **Descr**: Return Division
* **Request**: 123 | {Division:xxx} [IR5Division](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Division.ts) or  NumDivision
* **Response**: [IR5Division](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Division.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetDivision&Division=1](http://demo.restomax.com:1307/action?action=Resto:GetDivision&Division=1)

---
## Resto:SetDivision
* **Descr**: Update/Insert Selected Division
* **Request**: 123 | {Division:xxx} [IR5Division](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Division.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetDivision&Division=1&Description=Test](http://demo.restomax.com:1307/action?action=Resto:SetDivision&Division=1&Description=Test)

---
## Resto:DelDivision
* **Descr**: Delete Selected Division
* **Request**: 123 | {Division:xxx} [IR5Division](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Division.ts) or  NumDivision
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:DelDivision&Division=999](http://demo.restomax.com:1307/action?action=Resto:DelDivision&Division=999)

---
## Resto:GetAccueil
* **Descr**: Return Restomax Acceuil/Staffs Screen Data
* **Response**: [IR5Accueil](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Accueil.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetAccueil](http://demo.restomax.com:1307/action?action=Resto:GetAccueil)

---
## Resto:GetStaffs
* **Descr**: Return Staffs
* **Response**: Array of [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetStaffs](http://demo.restomax.com:1307/action?action=Resto:GetStaffs)

---
## Resto:GetStaff
* **Descr**: Return Selected Staff
* **Request**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetStaff&Staff=92](http://demo.restomax.com:1307/action?action=Resto:GetStaff&Staff=92)

---
## Resto:SetStaff
* **Descr**: Update/Insert Selected Staff
* **Request**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetStaff&{Staff:92,Description:12345}](http://demo.restomax.com:1307/action?action=Resto:SetStaff&{Staff:92,Description:12345})

---
## Resto:DelStaff
* **Descr**: Delete Selected Staff
* **Request**: [IR5Staff](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Staff.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:DelStaff&Staff=92](http://demo.restomax.com:1307/action?action=Resto:DelStaff&Staff=92)

---
## Resto:GetSalles
* **Descr**: Return All Salles
* **Response**: Array of [IR5Salle](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Salle.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetSalles](http://demo.restomax.com:1307/action?action=Resto:GetSalles)

---
## Resto:GetTblBtns
* **Descr**: Return All Table Btns
* **Response**: [IR5TblBtn](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5TblBtn.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetTblBtns](http://demo.restomax.com:1307/action?action=Resto:GetTblBtns)

---
## Resto:GetTblBtn
* **Descr**: Return Selected Table Btn
* **Response**: [IR5TblBtn](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5TblBtn.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetTblBtn&TblBtn=1](http://demo.restomax.com:1307/action?action=Resto:GetTblBtn&TblBtn=1)

---
## Resto:SetTblBtn
* **Descr**: Update/Insert Selected Table Btn
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetTblBtn&TblBtn=1&Description=Test](http://demo.restomax.com:1307/action?action=Resto:SetTblBtn&TblBtn=1&Description=Test)

---
## Resto:DelTblBtn
* **Descr**: Delete Selected Table Btn
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:DelTblBtn&TblBtn=123456](http://demo.restomax.com:1307/action?action=Resto:DelTblBtn&TblBtn=123456)

---
## Resto:GetTables
* **Descr**: Return All Tables (True Tables, Doors, ....)
* **Response**: Array of [IR5Tbl](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Tbl.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetTables](http://demo.restomax.com:1307/action?action=Resto:GetTables)

---
## Resto:GetTable
* **Descr**: Return selected Table
* **Response**: [IR5Tbl](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Tbl.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetTable&TblBtn=1](http://demo.restomax.com:1307/action?action=Resto:GetTable&TblBtn=1)

---
## Resto:SetTable
* **Descr**: Update/Insert Selected Table
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetTable&TblBtn=1&Description=Test](http://demo.restomax.com:1307/action?action=Resto:SetTable&TblBtn=1&Description=Test)

---
## Resto:DelTable
* **Descr**: Delete Selected Table
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:DelTable&TblBtn=123456](http://demo.restomax.com:1307/action?action=Resto:DelTable&TblBtn=123456)

---
## Resto:GetMvtTbls
* **Descr**: Return MvtTbls
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetMvtTbls](http://demo.restomax.com:1307/action?action=Resto:GetMvtTbls)

---
## Resto:GetCarte
* **Descr**: Return Restomax Carte/Pointage Screen Data
* **Response**: [IR5Carte](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Carte.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetCarte](http://demo.restomax.com:1307/action?action=Resto:GetCarte)

---
## Resto:GetCategs
* **Descr**: Return All Article Categs
* **Response**: Array of [IR5ArtCategory](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ArtCategory.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetCategs](http://demo.restomax.com:1307/action?action=Resto:GetCategs)

---
## Resto:GetCateg
* **Descr**: Return Selected Article Categ
* **Request**: need at least one key (CategNum,ExtRef,...). [IR5ArtCategory](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ArtCategory.ts)
* **Response**: [IR5ArtCategory](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ArtCategory.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetCateg&Categ=1](http://demo.restomax.com:1307/action?action=Resto:GetCateg&Categ=1)

---
## Resto:SetCateg
* **Descr**: Update/Insert Selected Article Categ
* **Request**: need at least one key (CategNum,ExtRef,...). [IR5ArtCategory](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ArtCategory.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetCateg&Categ={Num:1,Description:Test}](http://demo.restomax.com:1307/action?action=Resto:SetCateg&Categ={Num:1,Description:Test})

---
## Resto:DelCateg
* **Descr**: Delete Selected Article Categ
* **Request**: need at least one key (CategNum,ExtRef,...). [IR5ArtCategory](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ArtCategory.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:DelCateg&Categ={Num:1,Description:Test}](http://demo.restomax.com:1307/action?action=Resto:DelCateg&Categ={Num:1,Description:Test})

---
## Resto:GetGroups
* **Descr**: Return All Article Groups
* **Response**: Array of [IR5ArtGroup](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ArtGroup.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetGroups](http://demo.restomax.com:1307/action?action=Resto:GetGroups)

---
## Resto:GetGroup
* **Descr**: Return Selected Article Group
* **Request**: need at least one key (GroupNum,ExtRef,...). [TR5ArtGroup](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/TR5ArtGroup.ts)
* **Response**: [TR5ArtGroup](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/TR5ArtGroup.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetGroup&Group=1](http://demo.restomax.com:1307/action?action=Resto:GetGroup&Group=1)

---
## Resto:SetGroup
* **Descr**: Update/Insert Selected Article Group
* **Request**: need at least one key (GroupNum,ExtRef,...). [IR5ArtGroup](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ArtGroup.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetGroup&Group={Num:1,Description:Test}](http://demo.restomax.com:1307/action?action=Resto:SetGroup&Group={Num:1,Description:Test})

---
## Resto:DelGroup
* **Descr**: Delete Selected Article Group
* **Request**: need at least one key (GroupNum,ExtRef,...). [IR5ArtGroup](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ArtGroup.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:DelGroup&Group={Num:1,Description:Test}](http://demo.restomax.com:1307/action?action=Resto:DelGroup&Group={Num:1,Description:Test})

---
## Resto:GetTariffColors
* **Descr**: Return All TariffColors
* **Response**: Array of [IR5TariffColor](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5TariffColor.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetTariffColors](http://demo.restomax.com:1307/action?action=Resto:GetTariffColors)

---
## Resto:GetTariffColor
* **Descr**: Return Selected TariffColor
* **Request**: [IR5TariffColor](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5TariffColor.ts)
* **Response**: [IR5TariffColor](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5TariffColor.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetTariffColor&Tariff=1000](http://demo.restomax.com:1307/action?action=Resto:GetTariffColor&Tariff=1000)

---
## Resto:SetTariffColor
* **Descr**: Update/Insert Selected TariffColor
* **Request**: [IR5TariffColor](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5TariffColor.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetTariffColor&Tariff=1000&Description=Test](http://demo.restomax.com:1307/action?action=Resto:SetTariffColor&Tariff=1000&Description=Test)

---
## Resto:DelTariffColor
* **Descr**: Delete Selected TariffColor
* **Request**: [IR5TariffColor](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5TariffColor.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:DelTariffColor&Tariff=1000](http://demo.restomax.com:1307/action?action=Resto:DelTariffColor&Tariff=1000)

---
## Resto:GetSimplifiedArticles
* **Descr**: Return All Articles in Simplified Fmt (Including Prices for all Tariffs,...)
* **Response**: Array of [IR5SimplifiedArticle](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5SimplifiedArticle.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetSimplifiedArticles](http://demo.restomax.com:1307/action?action=Resto:GetSimplifiedArticles)  
> [Resto:GetSimplifiedArticles&{SearchKey:Groupe,SearchVal=regex:75|76}](http://demo.restomax.com:1307/action?action=Resto:GetSimplifiedArticles&{SearchKey:Groupe,SearchVal=regex:75|76})

---
## Resto:GetArticles
* **Descr**: Return All Articles
* **Response**: Array of [IR5Article](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Article.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetArticles](http://demo.restomax.com:1307/action?action=Resto:GetArticles)  
> [Resto:GetArticles&SearchVal=11&SearchKey=Categorie](http://demo.restomax.com:1307/action?action=Resto:GetArticles&SearchVal=11&SearchKey=Categorie)

---
## Resto:GetArticle
* **Descr**: Return Selected Article
* **Request**: [IR5Article](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Article.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetArticle&PLU=0001](http://demo.restomax.com:1307/action?action=Resto:GetArticle&PLU=0001)

---
## Resto:SetArticle
* **Descr**: Update/Insert Selected Article. Individual Flag can be added ex: Bloque:true|false
* **Request**: [IR5Article](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Article.ts) or  Array of IR5Article
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetArticle&PLU={PLU:1234,Nom:Test,Description=Test}](http://demo.restomax.com:1307/action?action=Resto:SetArticle&PLU={PLU:1234,Nom:Test,Description=Test})  
> [Resto:SetArticle&PLU={PLU:1234,Bloque:true}](http://demo.restomax.com:1307/action?action=Resto:SetArticle&PLU={PLU:1234,Bloque:true})  
> [Resto:SetArticle&PLU={PLU:1234,Bloque:false}](http://demo.restomax.com:1307/action?action=Resto:SetArticle&PLU={PLU:1234,Bloque:false})  
> [Resto:SetArticle&PLUs=[{PLU:1234,Bloque:false},{PLU:7890,Bloque:true}]](http://demo.restomax.com:1307/action?action=Resto:SetArticle&PLUs=[{PLU:1234,Bloque:false},{PLU:7890,Bloque:true}])

---
## Resto:DelArticle
* **Descr**: Delete Selected Article
* **Request**: [IR5Article](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Article.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:DelArticle&PLU={PLU:1234,Nom:Test}](http://demo.restomax.com:1307/action?action=Resto:DelArticle&PLU={PLU:1234,Nom:Test})

---
## Resto:GetArticlesStocks
* **Descr**: Return wanted articles Stock Status
* **Response**: Array of [IR5ArticleStock](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ArticleStock.ts) or [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetArticlesStocks](http://demo.restomax.com:1307/action?action=Resto:GetArticlesStocks)  
> [Resto:GetArticlesStocks&SearchVal=11&SearchKey=Categorie](http://demo.restomax.com:1307/action?action=Resto:GetArticlesStocks&SearchVal=11&SearchKey=Categorie)

---
## Resto:GetArticleStock
* **Descr**: Return wanted article Stock Status
* **Response**: [IR5ArticleStock](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ArticleStock.ts) or [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetArticleStock&PLU=0001](http://demo.restomax.com:1307/action?action=Resto:GetArticleStock&PLU=0001)

---
## Resto:GetSuppliers
* **Descr**: Return Suppliers(Fournisseurs)
* **Response**: Array of [IR5Supplier](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Supplier.ts) or [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetSuppliers](http://demo.restomax.com:1307/action?action=Resto:GetSuppliers)

---
## Resto:GetStockDocs
* **Descr**: Return wanted StockDocs(Bon Livraisons) in periode d1..d2
* **Response**: Array of [IR5StockDoc](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5StockDoc.ts) or [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetStockDocs&D1=20190101&D2=20191231](http://demo.restomax.com:1307/action?action=Resto:GetStockDocs&D1=20190101&D2=20191231)

---
## Resto:GetStockDoc
* **Descr**: Return wanted StockDoc(Bon Livraisons)
* **Request**: DocNr yyyymmdd-xxx
* **Response**: [IR5StockDoc](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5StockDoc.ts) or [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetStockDoc](http://demo.restomax.com:1307/action?action=Resto:GetStockDoc)

---
## Resto:SetStockDoc
* **Descr**: Update/Insert one StockDoc(Bon Livraisons). Details PLU must be unique.
* **Request**: [IR5StockDoc](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5StockDoc.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetStockDoc](http://demo.restomax.com:1307/action?action=Resto:SetStockDoc)

---
## Resto:DelStockDoc
* **Descr**: Delete one StockDoc(Bon Livraisons).
* **Request**: DocNr yyyymmdd-xxx
* **Response**: [IR5StockDoc](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5StockDoc.ts) or [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:DelStockDoc](http://demo.restomax.com:1307/action?action=Resto:DelStockDoc)

---
## Resto:GetEncaisse
* **Descr**: Return Restomax EnCaisse Screen Data
* **Response**: [IR5EnCaisse](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5EnCaisse.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetEncaisse](http://demo.restomax.com:1307/action?action=Resto:GetEncaisse)

---
## Resto:GetModePays
* **Descr**: Return All ModePays
* **Response**: Array of [IR5ModePay](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ModePay.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetModePays](http://demo.restomax.com:1307/action?action=Resto:GetModePays)

---
## Resto:GetModePay
* **Descr**: Return Selected ModePays
* **Request**: [IR5ModePay](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ModePay.ts)
* **Response**: [IR5ModePay](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ModePay.ts) or [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetModePay&ModePay=CASH](http://demo.restomax.com:1307/action?action=Resto:GetModePay&ModePay=CASH)

---
## Resto:SetModePay
* **Descr**: Update/Insert Selected ModePay
* **Request**: [IR5ModePay](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ModePay.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetModePay&ModePay=CASH&Description=Test](http://demo.restomax.com:1307/action?action=Resto:SetModePay&ModePay=CASH&Description=Test)

---
## Resto:DelModePay
* **Descr**: Delete Selected ModePay
* **Request**: [IR5ModePay](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5ModePay.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:DelModePay&ModePay=9999](http://demo.restomax.com:1307/action?action=Resto:DelModePay&ModePay=9999)

---
## Resto:GetRoutes
* **Descr**: Return Print Routes
* **Response**: Array of [IR5Route](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Route.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetRoutes](http://demo.restomax.com:1307/action?action=Resto:GetRoutes)

---
## Resto:GetPtrs
* **Descr**: Return Printers Devices
* **Response**: Array of [IR5PtrDevice](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5PtrDevice.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetPtrs](http://demo.restomax.com:1307/action?action=Resto:GetPtrs)

---
## Resto:GetPtrLnks
* **Descr**: Return PtrLnks
* **Response**: Array of [IR5Route2PtrLnk](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Route2PtrLnk.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetPtrLnks](http://demo.restomax.com:1307/action?action=Resto:GetPtrLnks)

---
## Resto:TicketStatus
* **Descr**: Return Get/Set Ticket Status
* **MoreInfos**: mark the ticket as Printed if Status:true or AutoRedirected
* **Request**: TicketStatus
* **Response**: TicketStatus
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:TicketStatus&{TicketId:123,Status:true}](http://demo.restomax.com:1307/action?action=Resto:TicketStatus&{TicketId:123,Status:true})

---
## Resto:GetMember
* **Descr**: Return Member
* **Request**: need at least one key (NumCard,ExtRef,Barcode,...). [IR5Member](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Member.ts)
* **Response**: [IR5Member](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Member.ts) or [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetMember&NumCarte=Test](http://demo.restomax.com:1307/action?action=Resto:GetMember&NumCarte=Test)

---
## Resto:SetMember
* **Descr**: Update/Insert Selected Member
* **Request**: need at least one key (NumCard,ExtRef,Barcode,...). [IR5Member](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Member.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetMember&{NumCarte:Test,Nom:Test,Description=Test}](http://demo.restomax.com:1307/action?action=Resto:SetMember&{NumCarte:Test,Nom:Test,Description=Test})

---
## Resto:GetMembers
* **Descr**: Search Members. Return Members List. Warning RegEx:Search use SQL RegEx pattern (similar to %blabla%)
* **Request**: {FromRow:0,PacketSize:50,SearchVal:zzz|star,SearchKey:MemberFieldName|star}.
* **Response**: Return Selected Members. Array of [IR5Member](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Member.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetMembers](http://demo.restomax.com:1307/action?action=Resto:GetMembers)

---
## Resto:GetMemberPhoto
* **Descr**: Return MemberPhoto
* **Request**: need at least one key (NumCard,ExtRef,Barcode,...). [IR5Member](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Member.ts)
* **Response**: [IR5MemberPhoto](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5MemberPhoto.ts) or [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetMemberPhoto&NumCarte=Test](http://demo.restomax.com:1307/action?action=Resto:GetMemberPhoto&NumCarte=Test)

---
## Resto:SetMemberPhoto
* **Descr**: Update MemberPhoto and Return updated MemberPhoto
* **Request**: need at least one key (NumCard,ExtRef,Barcode,...). [IR5MemberPhoto](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5MemberPhoto.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetMemberPhoto&{NumCarte:Test}](http://demo.restomax.com:1307/action?action=Resto:SetMemberPhoto&{NumCarte:Test})

---
## Resto:GetMemberPoints
* **Descr**: Return the Member Fidelity Points
* **Request**: need at least one key (NumCard,ExtRef,Barcode,...). [IR5Member](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Member.ts)
* **Response**: [IR5MemberTotPoints](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5MemberTotPoints.ts) or [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetMemberPoints&NumCarte=Test](http://demo.restomax.com:1307/action?action=Resto:GetMemberPoints&NumCarte=Test)

---
## Resto:SetMemberPoints
* **Descr**: Update the Member Fidelity Points
* **Request**: need at least one key (NumCard,ExtRef,Barcode,...). [IR5MemberTotPoints](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5MemberTotPoints.ts)
* **Response**: [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:SetMemberPoints&{NumCarte:Test}](http://demo.restomax.com:1307/action?action=Resto:SetMemberPoints&{NumCarte:Test})

---
## Resto:GetResource
* **Descr**: Return Restomax Internal Resource

* **Demo Urls**
> [Resto:GetResource&Resource=Resto_Restomax_Address](http://demo.restomax.com:1307/action?action=Resto:GetResource&Resource=Resto_Restomax_Address)

---
## Resto:GetUrl
* **Descr**: Return Url. Text Url are parsed by restomax <#Etab.Name>
* **MoreInfos**: same as http://localhost:8787/AnyFileInHtmlsPath
* **Request**: WantedUrl   
  can be any url below c:/restomax/HTMLS/xxx  
  can be any restomax resources  
  can be any restomax images
* **Response**: Wanted URL. Variable MimeType !

* **Demo Urls**
> [Resto:GetUrl&Resource=Resto_Restomax_Address](http://demo.restomax.com:1307/action?action=Resto:GetUrl&Resource=Resto_Restomax_Address)  
> [Resto:GetUrl&Image=200](http://demo.restomax.com:1307/action?action=Resto:GetUrl&Image=200)

---
## Resto:GetUri
* **Descr**: Same as GetUrl as JSON. Text Url are parsed by restomax <#Etab.Name>
* **MoreInfos**: same as http://localhost:8787/AnyFileInHtmlsPath
* **Request**: WantedUrl   
  can be any url below c:/restomax/HTMLS/xxx  
  can be any restomax resources  
  can be any restomax images
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetUri&Resource=Resto_Restomax_Address](http://demo.restomax.com:1307/action?action=Resto:GetUri&Resource=Resto_Restomax_Address)  
> [Resto:GetUri&Image=200](http://demo.restomax.com:1307/action?action=Resto:GetUri&Image=200)

---
## Resto:GetHisto
* **Descr**: Return Histo
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetHisto&Staff=123456&D1=20190101](http://demo.restomax.com:1307/action?action=Resto:GetHisto&Staff=123456&D1=20190101)

---
## Resto:GetArchive
* **Descr**: Return Archive
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetArchive&Staff=123456&D1=20190101](http://demo.restomax.com:1307/action?action=Resto:GetArchive&Staff=123456&D1=20190101)

---
## Resto:GetView
* **Descr**: Almost same as GetRpt (Deprecated)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetView&Staff=123456&View=Rpt_010&D1=20190101&D2=20991231](http://demo.restomax.com:1307/action?action=Resto:GetView&Staff=123456&View=Rpt_010&D1=20190101&D2=20991231)

---
## Resto:GetRpt
* **Descr**: Execute One Simple report or a Layout of reports or a A4 report
    * Simple report: see list with Resto:GetRptCodes
    * Layout of reports: Cloture,... or custom layout id
    * A4 report : SummaryView,RentaRpt,DailyView1,DailyView2,MonthlyView,PeriodeCompareView,TariffByArt,TariffsRpt,TariffByCateg, ... or custom layout id  
      In Case of A4 report, it return the generated PDF URL
* **Request**: Supported Params D1,D2,PLU,...
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetRpt&Staff=123456&Rpt=Rpt_012&D1=20190101&D2=20991231](http://demo.restomax.com:1307/action?action=Resto:GetRpt&Staff=123456&Rpt=Rpt_012&D1=20190101&D2=20991231)

---
## Resto:GetLedger
* **Descr**: Return Histo Ledger. Sales Data (list of sales tickets)
    - OSvc : Open Service Sales Ledger
    - TLSvc: TimeLine Sales all after LastSeq
    - Svcs : Periode[D1..D2] Sales Ledger
    - Apic : Periode[D1..D2] Sales Ledger in [Apic Format](https://api.apicbase.com/#38ea1d5e-cab0-40a6-9334-b73fb9fb3720)
* **Request**: Wanted Mode and Selection. [ILedgerIntf](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/ILedgerIntf.ts) or [LedgerDef](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/LedgerDef.ts)
    - {Staff:xxx, Params:{Mode:xxx, ModeParams }}
        - Mode:OSvc,TLSvc Params : {LastSeq: { DateHeure:xxx, NoSeq:zzzz }}
        - Mode:Svcs,Apic Params : {D1: yyyymmdd, D2: yyyymmdd}
* **Response**: according wanted mode. [ILedgerOSvc](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/ILedgerOSvc.ts) or [ILedgerTLSvc](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/ILedgerTLSvc.ts) or [ILedgerSvcs](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/ILedgerSvcs.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetLedger&{Staff:123456,Params:{Mode:OSvc}}](http://demo.restomax.com:1307/action?action=Resto:GetLedger&{Staff:123456,Params:{Mode:OSvc}})  
> [Resto:GetLedger&{Staff:123456,Params:{Mode:OSvc,LastSeq:{NoSeq:123,DateHeure:'2020.10.10T20:30:10'}}}](http://demo.restomax.com:1307/action?action=Resto:GetLedger&{Staff:123456,Params:{Mode:OSvc,LastSeq:{NoSeq:123,DateHeure:'2020.10.10T20:30:10'}}})  
> [Resto:GetLedger&{Staff:123456,Params:{Mode:TLSvc,LastSeq:{NoSeq:123,DateHeure:'2020.10.10T20:30:10'}}}](http://demo.restomax.com:1307/action?action=Resto:GetLedger&{Staff:123456,Params:{Mode:TLSvc,LastSeq:{NoSeq:123,DateHeure:'2020.10.10T20:30:10'}}})  
> [Resto:GetLedger&{Staff:123456,Params:{Mode:Svcs,D1:20200101,D2:20291231}}](http://demo.restomax.com:1307/action?action=Resto:GetLedger&{Staff:123456,Params:{Mode:Svcs,D1:20200101,D2:20291231}})  
> [Resto:GetLedger&{Staff:123456,Params:{Mode:Apic,D1:20200101,D2:20291231}}](http://demo.restomax.com:1307/action?action=Resto:GetLedger&{Staff:123456,Params:{Mode:Apic,D1:20200101,D2:20291231}})

---
## Resto:GetDashBoard
* **Descr**: Return DashBoard
* **Response**: [IDashboardIntf](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IDashboardIntf.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetDashBoard&{Staff:123456}](http://demo.restomax.com:1307/action?action=Resto:GetDashBoard&{Staff:123456})

---
## Resto:GetSvcDashBoard
* **Descr**: Return Service DashBoard (open service or last service)
* **Response**: [ISvcDashboardIntf](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/ISvcDashboardIntf.ts)
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetSvcDashBoard&{Staff:123456}](http://demo.restomax.com:1307/action?action=Resto:GetSvcDashBoard&{Staff:123456})

---
## Resto:GetPointage
* **Descr**: Get Pointage Details for a Tbl(Command)  
  Search in Tbls Open and/or Tbls Clotured according Request Params
* **Request**: [IR5PointageReq](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5PointageReq.ts) or  Hre  or  NoSales  or  GUID  
  Request Must have the Key(s) to find the Tbl(Command). It can be:
    - DteSvc/NoSvc/Hre ex: Tbl: {DteSvc:2020.12.04, NoSvc:1, Hre:378385}
    - DteSvc/NoSvc/NoSales ex: Tbl: {DteSvc:2020.12.04, NoSvc:1, NoSales:123456}
    - GUID ex: Tbl: {GUID:123123-465465-489498}
    - Tbl in this case will answer LastClotured ex: {Tbl:123456}
    - Hre in this case will search in open service
* **Response**: according wanted DetailsFmt. [IR5PointageResFmt1](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5PointageResFmt1.ts) or [IR5PointageResFmt2](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5PointageResFmt2.ts) or [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json
* **See also**: [IR5Delivry](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Delivry.ts) , [IR5PointageConso](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5PointageConso.ts) , [IR5PointagePay](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5PointagePay.ts)

* **Demo Urls**
> [Resto:GetPointage&Tbl=123](http://demo.restomax.com:1307/action?action=Resto:GetPointage&Tbl=123)  
> [Resto:GetPointage&{Tbl:{Tbl:123}}](http://demo.restomax.com:1307/action?action=Resto:GetPointage&{Tbl:{Tbl:123}})

---
## Resto:SetPointage
* **Descr**: Add Consos and/or Payments to a Tbl(Command), then Execute wanted action and Return GetPointage  
  Open the Table iff needed  
  Action=Cloture will perform needed action (pay,addition,...) and Close the Tbl Command
* **Request**: [IR5PointageReq](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5PointageReq.ts)  
  Table Id has two variants __Tbl:xxx.z__ or __NoTbl:xxx,SsTbl:z__  
  __Who__ defined by Staff:300|sss (staff may need some permission)  
  __Where__ defined by Station:304|306|308|309|kkkk (where to print,...)  
  __What__ defined by Consos,Pays and Action  
  Consos Article Obj : Missing Field are completed with some default (from Article,...)  
  Pays Obj : Missing Field are completed with some default (from ModePay,...)  
  Default Action is just __lancer__
* **Response**: according wanted DetailsFmt. [IR5PointageResFmt1](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5PointageResFmt1.ts) or [IR5PointageResFmt2](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5PointageResFmt2.ts) or [IRestoAnswer](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IRestoAnswer.ts)
* **Response content-type**: text/json
* **See also**: [IR5Delivry](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5Delivry.ts) , [IR5PointageConso](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5PointageConso.ts) , [IR5PointagePay](https://gitlab.com/restomax-public/restomax-metadata/tree/master/src/IR5PointagePay.ts)

* **Demo Urls**
> [Resto:SetPointage&{Staff:123456,Station:1,Tbl:{Tbl:1.0,Consos:[{PLU:1234}]}}](http://demo.restomax.com:1307/action?action=Resto:SetPointage&{Staff:123456,Station:1,Tbl:{Tbl:1.0,Consos:[{PLU:1234}]}})  
> [Resto:SetPointage&{Staff:123456,Station:1,Tbl:{Tbl:1.0,Action:Cloture,Consos:[{PLU:1234}]}}](http://demo.restomax.com:1307/action?action=Resto:SetPointage&{Staff:123456,Station:1,Tbl:{Tbl:1.0,Action:Cloture,Consos:[{PLU:1234}]}})  
> [Resto:SetPointage&{Staff:123456,Station:1,Tbl:{Tbl:1.0,Action:Cloture}}](http://demo.restomax.com:1307/action?action=Resto:SetPointage&{Staff:123456,Station:1,Tbl:{Tbl:1.0,Action:Cloture}})

---
## Resto:Action
* **Descr**: Return Wanted Action. Ex:Action=GetEtab same as GetEtab
* **Response content-type**: text/json

* **Demo Urls**
> [Resto:GetEtab](http://demo.restomax.com:1307/action?action=Resto:GetEtab)

---
