import 'package:json_annotation/json_annotation.dart';

import "IR5BtnProperties.dart" show IR5BtnProperties;

part 'IR5CarteBtn.g.dart';

// --------------------------------------------------------------------------------
enum BtnAction {
  ShowTools,
  Zoom,
  BIS,
  TblDescr,
  InOut,
  Offert,
  ChgPrix,
  ShortHold,
  LongHold,
  Suite,
  SplitAPart,
  Addition,
  EnCaisse,
  Cloture,
  MemberList,
  MemberInfo,
  TblDrapeau,
  FullTicket,
  PLUSearch,
  TagsSearch,
  AskTimeDrapeau,
  AskTelDrapeau,
  AskDivision
}
const Map<int, BtnAction> BtnActions = {
  0: BtnAction.ShowTools,
  1: BtnAction.Zoom,
  2: BtnAction.BIS,
  3: BtnAction.TblDescr,
  4: BtnAction.InOut,
  5: BtnAction.Offert,
  6: BtnAction.ChgPrix,
  7: BtnAction.ShortHold,
  8: BtnAction.LongHold,
  9: BtnAction.Suite,
  10: BtnAction.SplitAPart,
  11: BtnAction.Addition,
  12: BtnAction.EnCaisse,
  13: BtnAction.Cloture,
  14: BtnAction.MemberList,
  15: BtnAction.MemberInfo,
  16: BtnAction.TblDrapeau,
  17: BtnAction.FullTicket,
  18: BtnAction.PLUSearch,
  19: BtnAction.TagsSearch,
  20: BtnAction.AskTimeDrapeau,
  21: BtnAction.AskTelDrapeau,
  22: BtnAction.AskDivision,
};
int BtnActionToJson(BtnAction f) {
  return BtnActions.entries.firstWhere((element) => element.value == f).key;
}
// --------------------------------------------------------------------------------

/** Carte Onglets */
@JsonSerializable(explicitToJson: true)
class IR5CarteBtn {
  IR5CarteBtn({
    required this.Num,
    required this.PLU,
    required this.Categorie,
    required this.Groupe,
    required this.ModePay,
    required this.Action,
    required this.Onglet,
    required this.Ligne,
    required this.Col,
    required this.BtnProp,
  });

  factory IR5CarteBtn.fromJson(Map<String, dynamic>? json) =>
      _$IR5CarteBtnFromJson(json ?? {});
  Map<String, dynamic> toJson() => _$IR5CarteBtnToJson(this);

  @JsonKey(defaultValue: 0)
  final int Num;
  /** Btn can contain a Article OR a Categorie OR a Groupe OR a ModePay OR a Action */
  @JsonKey(defaultValue: '')
  final String PLU;
  @JsonKey(defaultValue: '')
  final String Categorie;
  @JsonKey(defaultValue: 0)
  final int Groupe;
  @JsonKey(defaultValue: '')
  final String ModePay;
  // BtnAction Action;
  @JsonKey(defaultValue: 0)
  final int Action;
  @JsonKey(defaultValue: 0)
  final int Onglet;
  @JsonKey(defaultValue: 0)
  final int Ligne;
  @JsonKey(defaultValue: 0)
  final int Col;
  /** Some Btn Propr should be overrided by Article.BtnPropr,... */
  final IR5BtnProperties BtnProp;
}
