// --------------------------------------------------------------------------------

import 'package:json_annotation/json_annotation.dart';

part 'IR5Division.g.dart';

/** Table Division ex:Etage,Terrasse,... */
@JsonSerializable()
class IR5Division {
  const IR5Division({
    required this.Num,
    required this.Nom,
    required this.Description,
    required this.Flags,
  });

  factory IR5Division.update(Map<String, dynamic>? json, [Map<String, dynamic>? src]) => IR5Division.fromJson({...json ?? {}, ...src ?? {}});
  factory IR5Division.fromJson(Map<String, dynamic>? json) => _$IR5DivisionFromJson(json ?? {});
  Map<String, dynamic> toJson() => _$IR5DivisionToJson(this);

  /** Just a #Num used as primary key unique id */
  @JsonKey(defaultValue: 0)
  final int Num;
  /** Just a Name */
  @JsonKey(defaultValue: '')
  final String Nom;
  /** Just a free Description */
  @JsonKey(defaultValue: '')
  final String Description;
  /** Division FLAGS [0..63] */
  @JsonKey(defaultValue: 0)
  final int Flags;
}
