import 'package:json_annotation/json_annotation.dart';

import 'IR5ArtCategory.dart';
import 'IR5ArtGroup.dart';
import 'IR5Article.dart';
import 'IR5Division.dart';
import 'IR5Etab.dart';
import 'IR5Image.dart';
import 'IR5ModePay.dart';
import 'IR5PtrDevice.dart';
import 'IR5Restomax.dart';
import 'IR5Route.dart';
import 'IR5Route2PtrLnk.dart';
import 'IR5Salle.dart';
import 'IR5Service.dart';
import 'IR5Staff.dart';
import 'IR5Station.dart';
import 'IR5TariffColor.dart';
import 'IR5Tbl.dart';

part 'IR5GetDataIntf.g.dart';

@JsonSerializable(explicitToJson: true)
class RMXData {
  /**
   *
      // Etab                                      : IR5Etab;
      // Stations                                  : IR5Station[];
      // Services                                  : IR5Service[];
      // Divisions                                 : IR5Division[];
      // Staffs                                    : IR5Staff[];
      // Salles                                    : IR5Salle[];
      // Tbls                                      : IR5Tbl[];
      // Articles                                  : IR5Article[];
      // Categories                                : IR5ArtCategory[];
      // Groupes                                   : IR5ArtGroup[];
      // TariffColors                              : IR5TariffColor[];
      // ModePays                                  : IR5ModePay[];
      // Routes                                    : IR5Route[];
      // Ptrs                                      : IR5PtrDevice[];
      // Route2PtrLinks                            : IR5Route2PtrLnk[];
      // Images                                    : IR5Image[];
      // Restomax                                  : IR5Restomax;
   */

  RMXData({
    required this.etab,
    required this.stations,
    required this.services,
    required this.divisions,
    required this.staffs,
    required this.salles,
    required this.tbls,
    required this.articles,
    required this.categories,
    required this.groupes,
    required this.tariffColors,
    required this.modePays,
    required this.routes,
    required this.ptrs,
    required this.route2PtrLinks,
    required this.images,
    required this.restomax,
  });

  factory RMXData.fromJson(Map<String, dynamic>? json) => _$RMXDataFromJson(json ?? {});
  Map<String, dynamic> toJson() => _$RMXDataToJson(this);

  @JsonKey(name: 'Etab')
  final IR5Etab etab;
  @JsonKey(name: 'Stations', defaultValue: [])
  final List<IR5Station> stations;
  @JsonKey(name: 'Services', defaultValue: [])
  final List<IR5Service> services;
  @JsonKey(name: 'Divisions', defaultValue: [])
  final List<IR5Division> divisions;
  @JsonKey(name: 'Staffs', defaultValue: [])
  final List<IR5Staff> staffs;
  @JsonKey(name: 'Salles', defaultValue: [])
  final List<IR5Salle> salles;
  @JsonKey(name: 'Tbls', defaultValue: [])
  final List<IR5Tbl> tbls;
  @JsonKey(name: 'Articles', defaultValue: [])
  final List<IR5Article> articles;
  @JsonKey(name: 'Categories', defaultValue: [])
  final List<IR5ArtCategory> categories;
  @JsonKey(name: 'Groupes', defaultValue: [])
  final List<IR5ArtGroup> groupes;
  @JsonKey(name: 'TariffColors', defaultValue: [])
  final List<IR5TariffColor> tariffColors;
  @JsonKey(name: 'ModePays', defaultValue: [])
  final List<IR5ModePay> modePays;
  @JsonKey(name: 'Routes', defaultValue: [])
  final List<IR5Route> routes;
  @JsonKey(name: 'Ptrs', defaultValue: [])
  final List<IR5PtrDevice> ptrs;
  @JsonKey(name: 'Route2PtrLinks', defaultValue: [])
  final List<IR5Route2PtrLnk> route2PtrLinks;
  @JsonKey(name: 'Images', defaultValue: [])
  final List<IR5Image> images;
  @JsonKey(name: 'Restomax')
  final IR5Restomax restomax;
}
