import 'package:json_annotation/json_annotation.dart';

import "IR5TblBtn.dart" show IR5TblBtn;

// --------------------------------------------------------------------------------
part 'IR5Salle.g.dart';

/** Restaurant Salles (Tables container) */
@JsonSerializable(explicitToJson: true)
class IR5Salle {
  /** Table
   * Default NumTable for mode Pos (Direct Pointing)
   * - Station Number OR
   * - "V"+Staff Number OR
   * - "VG"+Staff Number OR
   * - "VS"+Station Number
   */
  @JsonKey(defaultValue: '')
  final String Num;

  /** Table or Salle Name
   * Displayed only if diff from NoTable
   */
  @JsonKey(defaultValue: '')
  final String Nom;

  /** Just a free Description */
  @JsonKey(defaultValue: '')
  final String Description;

  /** Image Num */
  @JsonKey(defaultValue: 0)
  final int Bmp;
  @JsonKey(defaultValue: [])
  final List<IR5TblBtn> TblBtns;

  IR5Salle({
    required this.Num,
    required this.Nom,
    required this.Description,
    required this.Bmp,
    required this.TblBtns,
  });

  factory IR5Salle.fromJson(Map<String, dynamic>? json) => _$IR5SalleFromJson(json ?? {});
  Map<String, dynamic> toJson() => _$IR5SalleToJson(this);
}
