// --------------------------------------------------------------------------------

import 'package:json_annotation/json_annotation.dart';

part 'IR5Service.g.dart';

/** Service aka Closure Z */
@JsonSerializable()
class IR5Service {
  const IR5Service({
    required this.Num,
    required this.Nom,
    required this.Description,
    required this.Flags,
  });

  factory IR5Service.update(Map<String, dynamic>? json, [Map<String, dynamic>? src]) => IR5Service.fromJson({...json ?? {}, ...src ?? {}});
  factory IR5Service.fromJson(Map<String, dynamic>? json) => _$IR5ServiceFromJson(json ?? {});
  Map<String, dynamic> toJson() => _$IR5ServiceToJson(this);

  /** Just a #Num used as primary key unique id */
  @JsonKey(defaultValue: 0)
  final int Num;

  /** Just a Name */
  @JsonKey(defaultValue: '')
  final String Nom;

  /** Just a free Description */
  @JsonKey(defaultValue: '')
  final String Description;

  /** Service Flags
   *   Bit 01 : ForceTariffHappyHour
   */
  @JsonKey(defaultValue: 0)
  final int Flags;
}
