// --------------------------------------------------------------------------------

import 'package:json_annotation/json_annotation.dart';

part 'IR5TariffColor.g.dart';

/** Tariff Color */
@JsonSerializable()
class IR5TariffColor {
  IR5TariffColor({
    required this.Tariff,
    required this.Nom,
    required this.Description,
    required this.InvoiceToCpy,
    required this.CpyPriceFml,
    required this.PriceFml,
    required this.Prices,
  });

  factory IR5TariffColor.fromJson(Map<String, dynamic>? json) => _$IR5TariffColorFromJson(json ?? {});
  Map<String, dynamic> toJson() => _$IR5TariffColorToJson(this);

  /** Tariff Num */
  @JsonKey(defaultValue: 0)
  final int Tariff;

  /** Just a Name */
  @JsonKey(defaultValue: '')
  final String Nom;

  /** Just a free Description */
  @JsonKey(defaultValue: '')
  final String Description;

  /** Catering Invoice to Cpy (created as Member) */
  @JsonKey(defaultValue: '')
  final String InvoiceToCpy;

  /** How to calc Cpy Price if not CpyPrice defined (ex: Price1*0.2) */
  @JsonKey(defaultValue: '')
  final String CpyPriceFml;

  /** How to calc EndUser Price if not Price defined (ex: Price1*0.8) */
  @JsonKey(defaultValue: '')
  final String PriceFml;
  @JsonKey(defaultValue: [])
  final List<dynamic> Prices;
}
