// --------------------------------------------------------------------------------

/** Histo aka Big Book */
enum OUFTIState { TblOpen, TblClosed, SvcClosed, SvcTransfered }

const Map<String, OUFTIState> OUFTIStates = {
  'O': OUFTIState.TblOpen,
  'U': OUFTIState.TblClosed,
  'F': OUFTIState.SvcClosed,
  'T': OUFTIState.SvcTransfered,
};
String OUFTIStateToJson(OUFTIState f) {
  return OUFTIStates.entries.firstWhere((element) => element.value == f).key;
}
// --------------------------------------------------------------------------------

/** Histo aka Big Book */
enum HistoAction {
  Ouverture,
  ReOuv,
  Lancer,
  Suite,
  Split,
  Transfert,
  FullTicket,
  AddProForma,
  Addition,
  Cloture,
  Article,
  ArticleMenuHead,
  ArticleMenuDetail,
  ArticleExternal,
  ArticleContainer,
  HotelLnk,
  MsgMemo,
  MsgSimple,
  MsgLinked,
  MsgPlus,
  MsgMinus,
  MsgMultiQty,
  MsgMultiPrice,
  ArticleMenuDetailLinked,
  DiscountManual,
  DiscountMulti,
  DiscountMember,
  DiscountRestoPass,
  DiscountFreeVoucher,
  Info,
  Separation,
  SeparationPay,
  AuCentimeter,
  Drapeau,
  TimeDrapeau,
  TelNrDrapeau,
  InfoBooking,
  InfoRoom,
  InfoMember,
  InfoFreeVoucher,
  Invoice,
  DelivryInfo,
  PayManual,
  PayMachine,
  PayJeton,
  PayMemberAccount,
  PayGiftCertificate,
  PayDebour,
  SvcOpen,
  SvcZClot,
  SvcZBox,
  StaffOpen,
  StaffClose,
  StaffPrestation,
  StaffWorkIN,
  StaffWorkOUT,
  StockBlocage,
  Barcontrol_IN,
  Barcontrol_REJECTED,
  Barcontrol_OUT,
  CashDrawer,
  RptPrinted,
  TicketSimple,
  AdditionDuplicata,
  InvoiceLogMsg,
  InvoiceReprint
}

const Map<String, HistoAction> HistoActions = {
  'O': HistoAction.Ouverture,
  '>': HistoAction.ReOuv,
  'L': HistoAction.Lancer,
  '+': HistoAction.Suite,
  'S': HistoAction.Split,
  's': HistoAction.Transfert,
  'z': HistoAction.FullTicket,
  'F': HistoAction.AddProForma,
  'A': HistoAction.Addition,
  'C': HistoAction.Cloture,
  'D': HistoAction.Article,
  'M': HistoAction.ArticleMenuHead,
  '1': HistoAction.ArticleMenuDetail,
  'X': HistoAction.ArticleExternal,
  'Z': HistoAction.ArticleContainer,
  'e': HistoAction.HotelLnk,
  'm': HistoAction.MsgMemo,
  'G': HistoAction.MsgSimple,
  'g': HistoAction.MsgLinked,
  'K': HistoAction.MsgPlus,
  '!': HistoAction.MsgMinus,
  'Q': HistoAction.MsgMultiQty,
  'U': HistoAction.MsgMultiPrice,
  'a': HistoAction.ArticleMenuDetailLinked,
  'R': HistoAction.DiscountManual,
  '^': HistoAction.DiscountMulti,
  '%': HistoAction.DiscountMember,
  'V': HistoAction.DiscountRestoPass,
  'b': HistoAction.DiscountFreeVoucher,
  '?': HistoAction.Info,
  '-': HistoAction.Separation,
  '=': HistoAction.SeparationPay,
  'f': HistoAction.AuCentimeter,
  'x': HistoAction.Drapeau,
  'N': HistoAction.TimeDrapeau,
  'q': HistoAction.TelNrDrapeau,
  ',': HistoAction.InfoBooking,
  't': HistoAction.InfoRoom,
  '#': HistoAction.InfoMember,
  'B': HistoAction.InfoFreeVoucher,
  'I': HistoAction.Invoice,
  'n': HistoAction.DelivryInfo,
  'H': HistoAction.PayMachine,
  'P': HistoAction.PayMemberAccount,
  'Y': HistoAction.PayGiftCertificate,
  '€': HistoAction.PayDebour,
  '{': HistoAction.SvcOpen,
  '}': HistoAction.SvcZClot,
  '|': HistoAction.SvcZBox,
  '(': HistoAction.StaffOpen,
  ')': HistoAction.StaffClose,
  '@': HistoAction.StaffPrestation,
  '[': HistoAction.StaffWorkIN,
  ']': HistoAction.StaffWorkOUT,
  '&': HistoAction.StockBlocage,
  '.': HistoAction.Barcontrol_IN,
  '/': HistoAction.Barcontrol_REJECTED,
  'T': HistoAction.CashDrawer,
  'p': HistoAction.RptPrinted,
  'J': HistoAction.TicketSimple,
  'k': HistoAction.AdditionDuplicata,
  'i': HistoAction.InvoiceLogMsg,
  'j': HistoAction.InvoiceReprint
};
String HistoActionToJson(HistoAction f) {
  return HistoActions.entries.firstWhere((element) => element.value == f).key;
}
// --------------------------------------------------------------------------------

/** Histo aka Big Book */
enum HistoActionClass { SalesAction, SalesConso, SalesPay, SalesInfo, LogInfo }
const Map<String, HistoActionClass> HistoActionClasses = {
  'SalesAction': HistoActionClass.SalesAction,
  'SalesConso': HistoActionClass.SalesConso,
  'SalesPay': HistoActionClass.SalesPay,
  'SalesInfo': HistoActionClass.SalesInfo,
  'LogInfo': HistoActionClass.LogInfo,
};
String HistoActionClassToJson(HistoActionClass f) {
  return HistoActionClasses.entries
      .firstWhere((element) => element.value == f)
      .key;
}
// --------------------------------------------------------------------------------

/** Histo aka Big Book */
enum HistoTaxClass { Z, Resto, Emport, Mixed }
const Map<String, HistoTaxClass> HistoTaxClasses = {
  'Z': HistoTaxClass.Z,
  'Resto': HistoTaxClass.Resto,
  'Emport': HistoTaxClass.Emport,
  'Mixed': HistoTaxClass.Mixed,
};
String HistoTaxClassToJson(HistoTaxClass f) {
  return HistoTaxClasses.entries
      .firstWhere((element) => element.value == f)
      .key;
}
// --------------------------------------------------------------------------------

/** Histo aka Big Book */
enum HistoTaxLvl { None, Low, Middle, Hight, Exempt }
const Map<int, HistoTaxLvl> HistoTaxLvls = {
  0: HistoTaxLvl.None,
  1: HistoTaxLvl.Low,
  2: HistoTaxLvl.Middle,
  3: HistoTaxLvl.Hight,
  9: HistoTaxLvl.Exempt,
};
int HistoTaxLvlToJson(HistoTaxLvl f) {
  return HistoTaxLvls.entries.firstWhere((element) => element.value == f).key;
}

// --------------------------------------------------------------------------------
enum LedgerMode { OSvcLedger, TLSvcLedger, SvcsLedger, ApicLedger }
const Map<String, LedgerMode> LedgerModes = {
  'OSvcLedger': LedgerMode.OSvcLedger,
  'TLSvcLedger': LedgerMode.TLSvcLedger,
  'SvcsLedger': LedgerMode.SvcsLedger,
  'ApicLedger': LedgerMode.ApicLedger,
};
String LedgerModeToJson(LedgerMode f) {
  return LedgerModes.entries.firstWhere((element) => element.value == f).key;
}
// --------------------------------------------------------------------------------

/**
 *
 * Return true is val is a conso [O,>,L,+,S,s,z,F,A,C] or a conso info [?,-,=,f,x,N,q,,,t,#,B,I,n]
 */
bool isConso(HistoAction val) {
  switch (val) {
    case HistoAction.Article:
    case HistoAction.ArticleMenuHead:
    case HistoAction.ArticleMenuDetail:
    case HistoAction.ArticleExternal:
    case HistoAction.ArticleContainer:
    case HistoAction.HotelLnk:
    case HistoAction.MsgMemo:
    case HistoAction.MsgSimple:
    case HistoAction.MsgLinked:
    case HistoAction.MsgPlus:
    case HistoAction.MsgMinus:
    case HistoAction.MsgMultiQty:
    case HistoAction.MsgMultiPrice:
    case HistoAction.ArticleMenuDetailLinked:
    case HistoAction.DiscountManual:
    case HistoAction.DiscountMulti:
    case HistoAction.DiscountMember:
    case HistoAction.DiscountRestoPass:
    case HistoAction.DiscountFreeVoucher:
    case HistoAction.Info:
    case HistoAction.Separation:
    case HistoAction.SeparationPay:
    case HistoAction.AuCentimeter:
    case HistoAction.Drapeau:
    case HistoAction.TimeDrapeau:
    case HistoAction.TelNrDrapeau:
    case HistoAction.InfoBooking:
    case HistoAction.InfoRoom:
    case HistoAction.InfoMember:
    case HistoAction.InfoFreeVoucher:
    case HistoAction.Invoice:
    case HistoAction.DelivryInfo:
      return true;
    default:
      return false;
  }
}
// --------------------------------------------------------------------------------

/**
 *
 * Return true is val is a pay [H,H,H,P,Y,€]
 */
bool isPay(HistoAction val) {
  switch (val) {
    case HistoAction.PayManual:
    case HistoAction.PayMachine:
    case HistoAction.PayJeton:
    case HistoAction.PayMemberAccount:
    case HistoAction.PayGiftCertificate:
    case HistoAction.PayDebour:
      return true;
    default:
      return false;
  }
}
// --------------------------------------------------------------------------------

/**
 *
 * Return true is val is a SalesInfo [?,-,=,f,x,N,q,,,t,#,B,I,n]
 */
bool isSalesInfo(HistoAction val) {
  switch (val) {
    case HistoAction.Info:
    case HistoAction.Separation:
    case HistoAction.SeparationPay:
    case HistoAction.AuCentimeter:
    case HistoAction.Drapeau:
    case HistoAction.TimeDrapeau:
    case HistoAction.TelNrDrapeau:
    case HistoAction.InfoBooking:
    case HistoAction.InfoRoom:
    case HistoAction.InfoMember:
    case HistoAction.InfoFreeVoucher:
    case HistoAction.Invoice:
    case HistoAction.DelivryInfo:
      return true;
    default:
      return false;
  }
}
// --------------------------------------------------------------------------------

/**
 *
 * Return SalesAction,SalesConso,SalesPay,SalesInfo,HistoAction
 */
HistoActionClass Action2Class(HistoAction val) {
  switch (val) {
    case HistoAction.Ouverture:
    case HistoAction.ReOuv:
    case HistoAction.Lancer:
    case HistoAction.Suite:
    case HistoAction.Split:
    case HistoAction.Transfert:
    case HistoAction.FullTicket:
    case HistoAction.AddProForma:
    case HistoAction.Addition:
    case HistoAction.Cloture:
      return HistoActionClass.SalesAction;
    case HistoAction.Article:
    case HistoAction.ArticleMenuHead:
    case HistoAction.ArticleMenuDetail:
    case HistoAction.ArticleExternal:
    case HistoAction.ArticleContainer:
    case HistoAction.HotelLnk:
    case HistoAction.MsgMemo:
    case HistoAction.MsgSimple:
    case HistoAction.MsgLinked:
    case HistoAction.MsgPlus:
    case HistoAction.MsgMinus:
    case HistoAction.MsgMultiQty:
    case HistoAction.MsgMultiPrice:
    case HistoAction.ArticleMenuDetailLinked:
    case HistoAction.DiscountManual:
    case HistoAction.DiscountMulti:
    case HistoAction.DiscountMember:
    case HistoAction.DiscountRestoPass:
    case HistoAction.DiscountFreeVoucher:
      return HistoActionClass.SalesConso;
    case HistoAction.PayManual:
    case HistoAction.PayMachine:
    case HistoAction.PayJeton:
    case HistoAction.PayMemberAccount:
    case HistoAction.PayGiftCertificate:
    case HistoAction.PayDebour:
      return HistoActionClass.SalesPay;
    case HistoAction.Info:
    case HistoAction.Separation:
    case HistoAction.SeparationPay:
    case HistoAction.AuCentimeter:
    case HistoAction.Drapeau:
    case HistoAction.TimeDrapeau:
    case HistoAction.TelNrDrapeau:
    case HistoAction.InfoBooking:
    case HistoAction.InfoRoom:
    case HistoAction.InfoMember:
    case HistoAction.InfoFreeVoucher:
    case HistoAction.Invoice:
    case HistoAction.DelivryInfo:
      return HistoActionClass.SalesInfo;
    default:
      return HistoActionClass.LogInfo;
  }
}
// --------------------------------------------------------------------------------

/**
 *
 * Return Action description text
 */
dynamic /* String | */ Action2Descr(dynamic /* HistoAction | */ val) {
  switch (val) {
    case HistoAction.Ouverture:
      return "Ouverture";
    case HistoAction.ReOuv:
      return "ReOuv";
    case HistoAction.Lancer:
      return "Lancer";
    case HistoAction.Suite:
      return "Suite";
    case HistoAction.Split:
      return "Split";
    case HistoAction.Transfert:
      return "Transft";
    case HistoAction.FullTicket:
      return "FullTicket";
    case HistoAction.AddProForma:
      return "Pro Forma";
    case HistoAction.Addition:
      return "Addition";
    case HistoAction.Cloture:
      return "Clôture";
    case HistoAction.Article:
      return "Article";
    case HistoAction.ArticleMenuHead:
      return "Menu";
    case HistoAction.ArticleMenuDetail:
      return "Au Menu";
    case HistoAction.ArticleExternal:
      return "Article Externe";
    case HistoAction.ArticleContainer:
      return "Article Container";
    case HistoAction.HotelLnk:
      return "Hotel Room";
    case HistoAction.MsgMemo:
      return "Mémo";
    case HistoAction.MsgSimple:
      return "Message Simple";
    case HistoAction.MsgLinked:
      return "Message.Linked";
    case HistoAction.MsgPlus:
      return "Message Plus";
    case HistoAction.MsgMinus:
      return "Message Minus";
    case HistoAction.MsgMultiQty:
      return "Message Multiplic.Quantite";
    case HistoAction.MsgMultiPrice:
      return "Message Multiplic.Prix";
    case HistoAction.ArticleMenuDetailLinked:
      return "Message Au Menu";
    case HistoAction.DiscountManual:
      return "Discount";
    case HistoAction.DiscountMulti:
      return "Multiplic.Discount";
    case HistoAction.DiscountMember:
      return "Member Discount";
    case HistoAction.DiscountRestoPass:
      return "RestoPass Discount";
    case HistoAction.DiscountFreeVoucher:
      return "Voucher Discount";
    case HistoAction.Info:
      return "Info";
    case HistoAction.Separation:
      return "Séparation Conso";
    case HistoAction.SeparationPay:
      return "Séparation Pay";
    case HistoAction.AuCentimeter:
      return "PxCM";
    case HistoAction.Drapeau:
      return "Drapeau";
    case HistoAction.TimeDrapeau:
      return "TimeDrapeau";
    case HistoAction.TelNrDrapeau:
      return "TelNrDrapeau";
    case HistoAction.InfoBooking:
      return "Réservation";
    case HistoAction.InfoRoom:
      return "Info Room";
    case HistoAction.InfoMember:
      return "Info Member";
    case HistoAction.InfoFreeVoucher:
      return "Info FreeVoucher";
    case HistoAction.Invoice:
      return "Invoice";
    case HistoAction.DelivryInfo:
      return "Delivry/Take-Away Info";
    case HistoAction.PayManual:
      return "Paiement";
    case HistoAction.PayMachine:
      return "Paiement Machine";
    case HistoAction.PayJeton:
      return "Paiement Jeton";
    case HistoAction.PayMemberAccount:
      return "Paiement Member Account";
    case HistoAction.PayGiftCertificate:
      return "Bon KDO";
    case HistoAction.PayDebour:
      return "Débour";
    case HistoAction.SvcOpen:
      return "Ouv.Service";
    case HistoAction.SvcZClot:
      return "Clot.Svc";
    case HistoAction.SvcZBox:
      return "Clot.Box";
    case HistoAction.StaffOpen:
      return "Staff In";
    case HistoAction.StaffClose:
      return "Staff Out";
    case HistoAction.StaffPrestation:
      return "Info Prestation Staff";
    case HistoAction.StaffWorkIN:
      return "Staff Clock IN";
    case HistoAction.StaffWorkOUT:
      return "Staff Clock Out";
    case HistoAction.StockBlocage:
      return "Info Blocage";
    case HistoAction.Barcontrol_IN:
      return "Barcontrol IN";
    case HistoAction.Barcontrol_REJECTED:
      return "Barcontrol REJECTED";
    case HistoAction.Barcontrol_OUT:
      return "Barcontrol OUT";
    case HistoAction.CashDrawer:
      return "Tiroir";
    case HistoAction.RptPrinted:
      return "Rpt";
    case HistoAction.TicketSimple:
      return "Ticket Spl.";
    case HistoAction.AdditionDuplicata:
      return "Addition Duplicata";
    case HistoAction.InvoiceLogMsg:
      return "Log Invoice Msg";
    case HistoAction.InvoiceReprint:
      return "Log RePrint InvTicket Msg";
    default:
      return "Invalid Action $val";
  }
}
